
import std.stdio;
import std.conv;

void main( char[][] args )
{
    int size, u;

    size= to!int(args[1]);
    u= to!int(args[2]);
    writeln(text(choose(2*size, size), "  ", nlimitchoices(2*size, size, u)));
}

pure int choose(int n, int m)
{
    if( m <= 0 )
        return 1;
    if( n <= 0 )
        return 0;
    return choose(n-1, m-1) * n / m;
}


pure ulong nlimitchoices(int n, int m, int u)
{
    if( u < 0 )
        return 0;
    else if( m == 0 )
        return 1;
    else {
        ulong count;
        foreach( int d; 0 .. n-m+1 )
            count += nlimitchoices(n-d-1, m-1, u-m*d);
        return count;
    }
}


pure ulong nlimitchoices_i(int n, int m, int u)
{
    int[] dstack;
    ulong count;
    int dind;

    dstack.length= m+1;
    dind= 0;
    while( dind >= 0 )
    {
        if( m ) {
            foreach( int ind; dind+1 .. dind+m )
                dstack[ind]= 0;
            dind += m-1;
            n -= m-1;
            m= 1;
        }
//        writeln(text(n, " ", m, " ", u, " ", dstack));
        ++count;
        while( dind >= 0 ) {
            ++dstack[dind];
            --n;
            u -= m;
            if( n >= m && u >= 0 )
                break;
            n += dstack[dind]+1;
            u += m * dstack[dind];
            ++m;
            --dind;
        }
    }
    return count;
}


ulong[int[3]] cache;

ulong nlimitchoices_m(int n, int m, int u)
{
    if( u < 0 )
        return 0;
    else if( m == 0 )
        return 1;
    int[3] argset= [n, m, u];
    ulong* val= argset in cache;
    if( val !is null )
        return *val;
    ulong count;
    foreach( int d; 0 .. n-m+1 )
        count += nlimitchoices_m(n-d-1, m-1, u-m*d);
    cache[argset]= count;
    return count;
}

