
import std.stdio;
import std.conv;
import std.bigint;

void main( char[][] args )
{
    BigInt n, m, u;

    m= BigInt(to!int(args[1]));
    u= BigInt(to!int(args[2]));
//    writeln(text(nlimitchoices_big(2*m, m, u)));
    n= 2 * m;
    writeln(text(*nlimitchoices_bigr(&n, &m, &u)));
}

BigInt nlimitchoices_big(BigInt n, BigInt m, BigInt u)
{
    if( u < 0 )
        return BigInt(0);
    else if( m == 0 )
        return BigInt(1);
    else {
        BigInt total;
        foreach( BigInt d; BigInt(0) .. n-m+1 )
            total += nlimitchoices_big(n-d-1, m-1, u-m*d);
        return total;
    }
}

BigInt *nlimitchoices_bigr(BigInt *n, BigInt *m, BigInt *u)
{
    if( *u < 0 )
        return new BigInt(0);
    else if( *m == 0 )
        return new BigInt(1);
    else {
        BigInt n1, m1, u1;
        n1 = *n - 1;
        m1 = *m - 1;
        u1 = *u;
        auto total= new BigInt(0);
        foreach( BigInt d; BigInt(0) .. *n-*m+1 ) {
            *total += *nlimitchoices_bigr(&n1, &m1, &u1);
            --n1;
            u1 -= *m;
        }
        return total;
    }
}

