
package main

import (
    "os"
    "strconv"
    "fmt"
    "math/big"
)

func l(n, m, u int64) int64 {
    if u < 0 {
        return 0
    }
    if m == 0 {
        return 1
    }
    var sum int64
    for d := int64(0); d <= n - m; d++ {
        sum += l(n-d-1, m-1, u-m*d)
    }
    return sum
}


var cache = make(map[[3]int64] int64)

func l_m(n, m, u int64) int64 {
    if u < 0 {
        return 0
    }
    if m == 0 {
        return 1
    }
    cached, found := cache[[3]int64{n,m,u}]
    if found {
        return cached
    }
    var sum int64
    for d := int64(0); d <= n - m; d++ {
        sum += l_m(n-d-1, m-1, u-m*d)
    }
    cache[[3]int64{n,m,u}] = sum
    return sum
}


func l_p(n, m, u int64) int64 {
    if u < 0 {
        return 0
    }
    if m == 0 {
        return 1
    }
    var ch = make(chan int64)
    go l_p1(n, m, u, ch)
    result0 := l_p(n-1, m-1, u)
    return result0 + <-ch
}

func l_p1(n, m, u int64, ch chan<- int64) {
    var sum int64
    for d := int64(1); d <= n - m; d++ {
        sum += l(n-d-1, m-1, u-m*d)
    }
    ch <- sum
}


var big0 = big.NewInt(0)
var big1 = big.NewInt(1)

func l_big(n, m, u *big.Int) *big.Int {
    if u.Sign() < 0 {
        return big0
    }
    if m.Sign() == 0 {
        return big1
    }
    var n1, m1, u1, count, sum big.Int
    n1.Sub(n, big1)
    m1.Sub(m, big1)
    u1.Set(u);
    for count.Sub(n, m); count.Sign() >= 0; count.Sub(&count, big1)  {
        sum.Add(&sum, l_big(&n1, &m1, &u1))
        n1.Sub(&n1, big1)
        u1.Sub(&u1, m)
    }
    return &sum
}

func main() {
    var m, u int64
    m, _ = strconv.ParseInt(os.Args[1], 0, 64)
    u, _ = strconv.ParseInt(os.Args[2], 0, 64)
    fmt.Println(l_m(2*m, m, u))
//    fmt.Println(l_big(big.NewInt(2*m), big.NewInt(m), big.NewInt(u)))
}

